// rbgxNgɂWNXBitSetiwb_j

#ifndef ___Class_BitSet
#define ___Class_BitSet

#include <limits>
#include <string>
#include <iostream>

//===== rbgxNgɂWNX =====//
class BitSet {
	// unsigned long^̃rbg
	static const int LONG_BIT = std::numeric_limits<unsigned long>::digits;

	// W
	unsigned long bits;

	//--- v͗vfƂđÓȒli0ȏLONG_BITjH ---//
	static bool is_valid(int v) {
		return v >= 0 && v < LONG_BIT;
	}

	//--- eō\W{e}̃rbgxNg𐶐 ---//
	static unsigned long set_of(int e) {
		return 1UL << e;
	}

public:
	//--- NXBitSetňvf̍őlƍŏlԋpÓIo֐ ---//
	static int max_element() { return LONG_BIT - 1; }
	static int min_element() { return 0; }

	//--- RXgN^ ---//
	BitSet() : bits(0UL) { }					// W𐶐

	//--- RXgN^ ---//
	BitSet(const int e[], int n) : bits(0UL) {	// int^z񂩂W𐶐
		for (int i = 0; i < n; i++)
			add(e[i]);
	}

	//--- We͊܂܂邩H ---//
	bool contains(int e) const {
		return is_valid(e) && (bits & set_of(e));
	}

	//--- Wɗvfeǉ ---//
	void add(int e) {
		if (is_valid(e))
			bits |= set_of(e);
	}

	//--- Wvfe폜 ---//
	void remove(int e) {
		if (is_valid(e))
			bits &= ~set_of(e);
	}

	//--- W͋WH ---//
	bool empty() const {
		return !bits;
	}

	//--- WɊ܂܂vf߂ ---//
	int size() const {
		int count = 0;
		unsigned long x = bits;
		while (x) {
			x &= x - 1;
			count++;
		}
		return count;
	}

	//--- WrƂ̐ϏWɍXV ---//
	BitSet& operator&=(const BitSet& r) {
		bits &= r.bits;
		return *this;
	}

	//--- WrƂ̘aWɍXV ---//
	BitSet& operator|=(const BitSet& r) {
		bits |= r.bits;
		return *this;
	}

	//--- WrƂ̍WɍXV ---//
	BitSet& operator^=(const BitSet& r) {
		bits ^= r.bits;
		return *this;
	}

	//--- WrƓH ---//
	bool operator==(const BitSet& r) const {
		return bits == r.bits;
	}

	//--- WrƓȂH ---//
	bool operator!=(const BitSet& r) const {
		return bits != r.bits;
	}

	//--- \"{a, b, c}"ԋpivfR}ŋ؂{}ň͂ށj---//
	std::string to_string() const;

	//--- rbgxNg̕\"010c10"ԋp---//
	std::string bit_string() const;
};

//--- }q ---//
std::ostream& operator<<(std::ostream& os, const BitSet& x);

#endif
