// }`NXQShape, Point, Line, HorzLine, VertLine, RectangleiQŁj

#ifndef ___Class_Shape
#define ___Class_Shape

#include <string>
#include <sstream>
#include <iostream>

//===== }`NXiۃNXj=====//
class Shape {
public:
	//--- zfXgN^ ---//
	virtual ~Shape() = 0;

	//---  ---//
	virtual Shape* clone() const = 0;				// z֐

	//--- ` ---//
	virtual void draw() const = 0;					// z֐

	//--- \ ---//
	virtual std::string to_string() const = 0;		// z֐

	//--- t` ---//
	void print() const {
		std::cout << to_string() << '\n';
		draw();
	}

	//--- fobOp\ ---//
	virtual void debug() const = 0;					// z֐
};

//--- zfXgN^ ---//
inline Shape::~Shape() { }

//--- fobOp\ ---//
inline void Shape::debug() const
{
	std::cout << "-- fobO --\n";
	std::cout << "^F" << typeid(*this).name() << '\n';
	std::cout << "AhXF" << this << '\n';
}

//===== _NX =====//
class Point : public Shape {
public:
	//--- ` ---//
	void draw() const {
		std::cout << "*\n";
	}

	//---  ---//
	Point* clone() const {
		return new Point;
	}

	//--- \ ---//
	std::string to_string() const {
		return "Point";
	}

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
	}
};

//===== NXiۃNXj =====//
class Line : public Shape {
protected:
	int length;			// 

public:
	//--- RXgN^ ---//
	Line(int len) : length(len) { }

	//--- ilengthj̃Qb^ ---//
	int get_length() const { return length; }

	//--- ilengthj̃Zb^ ---//
	void set_length(int len) { length = len; }

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "lengthF" << length << '\n';
	}
};

//===== NX =====//
class HorzLine : public Line {
public:
	//--- RXgN^ ---//
	HorzLine(int len) : Line(len) { }

	//---  ---//
	virtual HorzLine* clone() const {
		return new HorzLine(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++)
			std::cout << '-';
		std::cout << '\n';
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "HorzLine(length:" << length << ")";
		return os.str();
	}
};

//===== NX =====//
class VertLine : public Line {
public:
	//--- RXgN^ ---//
	VertLine(int len) : Line(len) { }

	//---  ---//
	virtual VertLine* clone() const {
		return new VertLine(length);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= length; i++)
			std::cout << "|\n";
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "VertLine(length:" << length << ")";
		return os.str();
	}
};

//===== `NX =====//
class Rectangle : public Shape {
	int width;		// 
	int height;		// 

public:
	//--- RXgN^ ---//
	Rectangle(int w, int h) : width(w), height(h) { }

	//---  ---//
	Rectangle* clone() const {
		return new Rectangle(width, height);
	}

	//--- ` ---//
	void draw() const {
		for (int i = 1; i <= height; i++) {
			for (int j = 1; j <= width; j++)
				std::cout << '*';
			std::cout << '\n';
		}
	}

	//--- \ ---//
	std::string to_string() const {
		std::ostringstream os;
		os << "Rectangle(width:" << width << ", height:" << height << ")";
		return os.str();
	}

	//--- fobOp\ ---//
	void debug() const {
		Shape::debug();
		std::cout << "width F" << width << '\n';
		std::cout << "heightF" << height << '\n';
	}
};

//--- }`NXQp̑}q ---//
inline std::ostream& operator<<(std::ostream& os, const Shape& s)
{
	return os << s.to_string(); // to_stringԋp镶\
}

#endif
