﻿// ベクトルの要素を表示（for_eachとファンクタ）

#include <vector>
#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;

//=== 値に続けてスペースを１個出力 ===//
template <class Type>
struct put1 : public unary_function<const Type&, void> {
	void operator()(const Type& n) {
		cout << n << ' ';		// スペース１個
	}
};

//=== 値に続けてスペースを２個出力 ===//
template <class Type>
struct put2 : public unary_function<const Type&, void> {
	void operator()(const Type& n) {
		cout << n << "  ";		// スペース２個
	}
};

int main()
{
	vector<int> x;
	for (vector<int>::size_type i = 0; i < 10; i++)
		x.push_back(i);

	for_each(x.begin(), x.end(), put1<int>());	// スペース１個で区切って表示
	cout << '\n';

	for_each(x.begin(), x.end(), put2<int>());	// スペース２個で区切って表示
	cout << '\n';
}
