﻿// ベクトルに対する要素の挿入と削除

#include <vector>
#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;

//--- [first, last)の全要素を{}で囲んで順に表示 ---//
template<class InputIterator>
void print(InputIterator first, InputIterator last)
{
	cout << "{ ";
	for (InputIterator i = first; i != last; i++)
		cout << *i << " ";
	cout << "}";
}

int main()
{
	vector<int> x;

	for (vector<int>::size_type i = 0; i < 10; i++)
		x.push_back(i);

	random_shuffle(x.begin(), x.end());			// シャッフル
	cout << "シャッフル：";  print(x.begin(), x.end());  cout << '\n';

	sort(x.begin(), x.end());					// 昇順ソート
	cout << "昇順ソート：";  print(x.begin(), x.end());  cout << '\n';

	sort(x.begin(), x.end(), greater<int>());	// 降順ソート
	cout << "降順ソート：";  print(x.begin(), x.end());  cout << '\n';
}
