﻿// 反復子によるベクトル要素の逆向き走査

#include <vector>
#include <iostream>

using namespace std;

int main()
{
	vector<int> v(5);	// 要素数は5
	int value = 5;

	// 末尾から先頭へと走査して値を代入
	for (vector<int>::reverse_iterator p = v.rbegin(); p != v.rend(); p++)
		*p = value--;

	// 先頭から末尾へと走査して値を表示
	for (vector<int>::const_iterator p = v.begin(); p != v.end(); p++) 
		cout << *p << ' ';
	cout << '\n';

	vector<int>::difference_type d1 = v.end()  - v.begin();
	vector<int>::difference_type d2 = v.rend() - v.rbegin();
	cout << "v.end()  - v.begin()  = " << d1 << '\n';
	cout << "v.rend() - v.rbegin() = " << d2 << '\n';
}
