﻿// 文字列に各種アルゴリズムを適用

#include <cctype>
#include <string>
#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;

//--- 小文字を大文字に変換 --//
struct to_upper {
	char operator()(char c) { return toupper(c); }
};

//--- 大文字を小文字に変換 --//
struct to_lower {
	char operator()(char c) { return tolower(c); }
};

//--- 大文字と小文字を反転 ---//
struct invert_case {
	char operator()(char c) {
		return islower(c) ? toupper(c) : isupper(c) ? tolower(c) : c;
	}
};

int main()
{
	string s1;
	cout << "文字列を入力せよ：";
	cin >> s1;
	string s2(s1);

	transform(s1.begin(), s1.end(), s2.begin(), invert_case());	// 大／小文字の反転
	cout << "大小の反転：" << s2 << '\n';

	transform(s1.begin(), s1.end(), s2.begin(), to_upper());	// 大文字化
	cout << "全大文字化：" << s2 << '\n';

	transform(s1.begin(), s1.end(), s2.begin(), to_lower());	// 小文字化
	cout << "全小文字化：" << s2 << '\n';

	random_shuffle(s1.begin(), s1.end());			// シャッフル
	cout << "シャッフル：" << s1 << '\n';

	sort(s1.begin(), s1.end());						// 昇順ソート
	cout << "昇順ソート：" << s1 << '\n';

	sort(s1.begin(), s1.end(), greater<char>());	// 降順ソート
	cout << "降順ソート：" << s1 << '\n';
}