﻿// 文字列の配列のベクトル

#include <string>
#include <vector>
#include <iostream>

using namespace std;

//--- ２次元配列による文字列の配列をvector<string>に変換 ---//
vector<string> str2dary_to_vec(char* p, int h, int w)
{
	vector<string> temp;
	for (int i = 0; i < h; i++)
		temp.push_back(&p[i * w]);
	return temp;
}

//--- ポインタによる文字列の配列をvector<string>に変換 ---//
vector<string> strptary_to_vec(char** p, int n)
{
	vector<string> temp;
	for (int i = 0; i < n; i++)
		temp.push_back(p[i]);
	return temp;
}

int main()
{
	char a[][5] = {"LISP", "C", "Ada"};		// 配列による文字列の配列
	char* p[]   = {"PAUL", "X", "MAC"};		// ポインタによる文字列の配列

	vector<string> sa = str2dary_to_vec(&a[0][0], 3, 5);
	for (vector<string>::size_type i = 0; i < sa.size(); i++)
		cout << "sa[" << i << "] = " << sa[i] << '\n';

	vector<string> sp = strptary_to_vec(p, 3);
	for (vector<string>::size_type i = 0; i < sp.size(); i++)
		cout << "sp[" << i << "] = " << sp[i] << '\n';
}
