﻿// stringの構築例（その２）

#include <string>
#include <iostream>

using namespace std;

int main()
{
	string s1("ABCDEFGHIJK");		// 文字列"ABCDEFGHIJK"


//--- 第２引数が不正である例 ---//
//	string sa(s1, 55, 3);			// 55文字目はないのでout_of_rangeが送出される
//	string sb(s1, -5, 2);			// 同じくout_of_rageが送出される

//	cout << "sa = " << sa << '\n';
//	cout << "sb = " << sb << '\n';


//--- 第３引数は負値でも可 ---//
	string sx(s1, 2, 128);			// 128文字ないので末尾文字までがコピーされる
	string sy(s1, 2, -5);			// 末尾文字までがコピーされる
	string sz(s1, 2, string::npos);	// 末尾文字までがコピーされる

	cout << "sx = " << sx << '\n';
	cout << "sy = " << sy << '\n';
	cout << "sz = " << sz << '\n';


//--- 文字での初期化はできないが代入は可能 ---//
//	string sc1 = 'X';	// エラー
	string sc2;
	sc2 = 'X';			// OK

//	cout << "sc1 = " << sc1 << '\n';
	cout << "sc2 = " << sc2 << '\n';


//--- ２項+演算子による連結 ---//
	string st1 = "ABC";
	string st2 = "ABC" + s1;
	string st3 = st1 + st2;
	string st4 = st1 + "UVW";
//	string st5 = "UVW" + "XYZ";				// エラー
	string st6 = st1 + "UVW" + "XYZ";
//	string st7 = "UVW" + "XYZ" + s1;		// エラー
	string st8 = "ABC" + 'D';				// 不正
	string st9 = st1 + 'D';					// エラー
	
	cout << "st1 = " << st1 << '\n';
	cout << "st2 = " << st2 << '\n';
	cout << "st3 = " << st2 << '\n';
	cout << "st4 = " << st4 << '\n';
//	cout << "st5 = " << st5 << '\n';
	cout << "st6 = " << st6 << '\n';
//	cout << "st7 = " << st7 << '\n';
	cout << "st8 = " << st8 << '\n';
	cout << "st9 = " << st9 << '\n';

//--- 複合代入演算子+=による連結 ---//
	st9 += st1;			// string型文字列を連結
	st9 += "ABC";		// Ｃ言語文字列を連結
	st9 += 'D';			// 単一文字を連結

	cout << "st9 = " << st9 << '\n';
}
